      SUBROUTINE INFOTP()
C
C     Name: MPI Begin
C     Author: Anthony Leboissetier
C     Objective: To characterize the virtual 3D topology.
C     Called by: Surfer
C                   NPROCS: Number of PROCesseS.
C 
      include "undefined.h"
      INCLUDE 'mpif.h' 
      INTEGER IERR00
C
C.... Preliminaries
      NEIGHB(1) = -1
      NEIGHB(2) = -1
C.... Cherching for main neighbours.
      CALL MPI_CART_SHIFT(COMM2D,0,1,NEIGHB(1),NEIGHB(2),IERR00)
      CALL CHECK_MPI(IERR00,22)
C
      WRITE(*,*)'PPRANK',PPRANK,' voisins  :',NEIGHB(1),NEIGHB(2)
      RETURN
      END

      SUBROUTINE CHECK_MPI(IERR00,I)
      INCLUDE "undefined.h"
      INCLUDE 'mpif.h'
      INTEGER I,IERR00
      IF (IERR00.NE.MPI_SUCCESS) THEN
         WRITE(*,*) "pprank = ",pprank," FAILED MPI CALL AT CHECK POINT", I
         STOP
      ENDIF
      IF (DEBUG_MPI.EQ.1) THEN
         WRITE(*,*) "pprank = ",pprank," MPI SUCCESS AT CHECK POINT", I
      END IF
      RETURN
      END
